package com.sungard.jpa.service;

import java.util.Hashtable;

import javax.naming.Context;
import javax.naming.Name;
import javax.naming.NamingException;
import javax.naming.spi.ObjectFactory;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.context.ApplicationContext;
import org.springframework.transaction.jta.JtaTransactionManager;

public class JencksTxManagerFactory implements ObjectFactory {
    private static Logger logger = LoggerFactory.getLogger(JencksTxManagerFactory.class);
    
    public Object getObjectInstance(Object obj,
				    Name jndiName, 
				    Context nameCtx, 
				    Hashtable environment)
		  throws NamingException {
    	logger.info("jndiName: " + jndiName);

    	ApplicationContext appContext = ApplicationContextUtils.getApplicationContext();
    	return ((JtaTransactionManager)appContext.getBean("transactionManager")).getTransactionManager();
    }
}

