package com.sungard.jpa.service;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import com.sungard.jpa.test.Employee;

public class EmployeeService {
	//For JTA
	@PersistenceContext
	private EntityManager em;
	
	@Transactional(propagation=Propagation.MANDATORY)
	public void addEmployee(Employee e) throws Exception {
		if(e.getEmpid() >1000) throw new Exception();
		em.persist(e);
	}
}
